Problem Description
《Journey to the West》(also 《Monkey》) is one of the Four Great Classical Novels of Chinese literature. It was written by Wu Cheng'en during the Ming Dynasty. In this novel, Monkey King Sun Wukong, pig Zhu Bajie and Sha Wujing, escorted Tang Monk to India to get sacred Buddhism texts.

During the journey, Tang Monk was often captured by
demons. Most of demons wanted to eat Tang Monk to achieve immortality,
but some female demons just wanted to marry him because he was handsome.
So, fighting demons and saving Monk Tang is the major job for Sun
Wukong to do.

Once, Tang Monk was captured by the demon White
Bones. White Bones lived in a palace and she cuffed Tang Monk in a room.
Sun Wukong managed to get into the palace. But to rescue Tang Monk, Sun
Wukong might need to get some keys and kill some snakes in his way.

The palace can be described as a matrix of characters. Each character
stands for a room. In the matrix, 'K' represents the original position
of Sun Wukong, 'T' represents the location of Tang Monk and 'S' stands
for a room with a snake in it. Please note that there are only one 'K'
and one 'T', and at most five snakes in the palace. And, '.' means a
clear room as well '#' means a deadly room which Sun Wukong couldn't get
in.

There may be some keys of different kinds scattered in
the rooms, but there is at most one key in one room. There are at most 9
kinds of keys. A room with a key in it is represented by a digit(from
'1' to '9'). For example, '1' means a room with a first kind key, '2'
means a room with a second kind key, '3' means a room with a third kind
key... etc. To save Tang Monk, Sun Wukong must get ALL kinds of keys(in
other words, at least one key for each kind).

For each step,
Sun Wukong could move to the adjacent rooms(except deadly rooms) in 4
directions(north, west, south and east), and each step took him one
minute. If he entered a room in which a living snake stayed, he must
kill the snake. Killing a snake also took one minute. If Sun Wukong
entered a room where there is a key of kind N, Sun would get that key if
and only if he had already got keys of kind 1,kind 2 ... and kind N-1.
In other words, Sun Wukong must get a key of kind N before he could get a
key of kind N+1 (N>=1). If Sun Wukong got all keys he needed and
entered the room in which Tang Monk was cuffed, the rescue mission is
completed. If Sun Wukong didn't get enough keys, he still could pass
through Tang Monk's room. Since Sun Wukong was a impatient monkey, he
wanted to save Tang Monk as quickly as possible. Please figure out the
minimum time Sun Wukong needed to rescue Tang Monk.

 
Input
There are several test cases.

For each case, the first line includes two integers N and M(0 < N
<= 100, 0<=M<=9), meaning that the palace is a N×N matrix and
Sun Wukong needed M kinds of keys(kind 1, kind 2, ... kind M).

Then the N × N matrix follows.

The input ends with N = 0 and M = 0.

 
Output
For each test case, print the minimum time (in minutes) Sun Wukong
needed to save Tang Monk. If it's impossible for Sun Wukong to complete
the mission, print "impossible"(no quotes).
 
Sample Input
3 1
K.S
##1
1#T
3 1
K#T
.S#
1#.
3 2
K#T
.S.
21.
0 0
 
Sample Output
5
impossible
8
 
题意
孙悟空要去救师傅,K代表起点,T为唐僧位置,S代表有蛇的房间(不会超过五条蛇),#为剧毒房间,无法进入 带数字的房间为有钥匙的房间(不超过9个),孙悟空必须先拿到第一个钥匙,再拿第二个....最后拿到第m个钥匙,才能解救唐僧 没有拿到第m个钥匙的时候可以路过但是不能解救唐僧,路过有蛇的房间的时候需要花一分钟杀蛇,杀掉之后再经过时就不用再花时间杀蛇,但是每经过一个房间需要花费一分钟,求就出唐僧最短的时间。
 
分析
由于杀蛇需要花费时间,所以不能是找到了唐僧就是最短时间,必须将所有的可能性取最小值,这是这道题和不同的bfs最大的不同,另外,需要一个五位二进制数来存目前杀蛇的情况(这样一个数就可以概括全部的五条蛇,当然我认为也可以用一个数组来存,但是太费空间)
 
下面是代码,直接看代码更容易理解
  #include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <queue>
using namespace std;
#define N 105
#define INF 0x3f3f3f3f struct node
{
int x, y, t, key, snake;
node() {}
node(int x, int y, int t, int key, int snake) : x(x), y(y), t(t), key(key), snake(snake) {}
};
bool vis[N][N][][];
int n, m, sx, sy, ex, ey;
int dx[] = {, -, , }, dy[] = {, , , -};
char maze[N][N]; bool check(int x, int y)
{
if(<=x&&x<n&&<=y&&y<n&&maze[x][y]!='#') return true; //判断能不能走
return false;
} void bfs()
{
int ans = INF;
memset(vis, , sizeof(vis));
queue<node> que;
while(!que.empty()) que.pop(); //清空队列 因为有多个测试
que.push(node(sx, sy, , , ));
while(!que.empty()) {
node top = que.front(); que.pop();
int x = top.x, y = top.y, key = top.key, snake = top.snake, t = top.t;
if(key == m && maze[x][y] == 'T') {
ans = min(ans, t); //取最短时间
}
if(vis[x][y][key][snake] != ) continue; //判断当前“状态”有没有访问过,注意是“状态”,不是房间,房间是可以重复访问的
vis[x][y][key][snake] = ;
for(int i = ; i < ; i++) {
int nx = x + dx[i], ny = y + dy[i];
if(!check(nx, ny)) continue;
node now = top;
if('A' <= maze[nx][ny] && maze[nx][ny] <= 'G') {
//只有五条蛇,不能写 <= 'Z'
int s = maze[nx][ny] - 'A';
if((<<s) & now.snake) ; //如果蛇被打了
else {
now.snake |= (<<s); //没被打,时间加1 记录打蛇情况
now.t++;
}
} else if(maze[nx][ny] - '' == now
.key + ) {
now.key++;
}
now.t++;
que.push(node(nx, ny, now.t, now.key, now.snake));
}
}
if(ans != INF) printf("%d\n", ans);
else printf("impossible\n");
} int main()
{
while(~scanf("%d%d", &n, &m), n+m) {
int cnt = ;
for(int i = ; i < n; i++) {
scanf("%s", maze[i]);
}
for(int i = ; i < n; i++) {
for(int j = ; j < n; j++) {
if(maze[i][j] == 'K') sx = i, sy = j;
if(maze[i][j] == 'S') {maze[i][j] = cnt+'A'; cnt++;}
}
}
bfs();
}
return ;
}

最新文章

  1. 【JS/CSS3】实现带预览图幻灯片效果~
  2. appium实现截图和清空EditText
  3. 基于.net开发chrome核心浏览器【七】
  4. 让VS默认以管理员身份运行
  5. 在A*寻路中使用二叉堆
  6. java的split的坑,会忽略空值
  7. junit组合模式应用
  8. [转] Initial Impressions on GraphQL &amp; Relay
  9. ASP.NET-FineUI开发实践-4
  10. c语言条件表达式误区1
  11. 201521123022 《Java程序设计》 第十一周学习总结
  12. directdraw显示yuv420(YV12)
  13. java数组冒泡排序
  14. JAVA实训第三次作业
  15. 神经网络架构pytorch-MSELoss损失函数
  16. 树莓派 Raspberry Pi 更换国内源
  17. Hive集成HBase实践
  18. eclipse新建maven工程的各种坑
  19. 网易云易盾CTO朱浩齐:我们是如何用AI赋能内容安全?
  20. mac 10.9 dock在多屏幕间移动

热门文章

  1. 初学Python——软件目录结构规范
  2. P3368 【模板】树状数组 2--洛谷luogu
  3. 20175310 《Java程序设计》第8周学习总结
  4. IIS7启动优化
  5. Jenkins-配置LDAP认证
  6. 【Java并发.5】基础构建模块
  7. H5 颜色属性
  8. webpack之loader和plugin简介
  9. hdu 2063 给男女匹配 (匈牙利算法)
  10. AndroidManifest.xml文件解析